/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.army.entities;

import fb.util.Resources;


/**
 * a dragon
 * @author farfpeuf
 *
 */
public class Dragon extends FlyingShootingUnit{

	/**
	 * create dragon from line read in catalog
	 * 
	 * @param ligne
	 *            catalog line
	 * @param linenumber
	 *            line number
	 */
	public Dragon(String ligne,int linenumber){

			super(ligne,linenumber);

			projectilesNumber=3;
			shortRange=2;
			longRange=6;
			midRange=shortRange+longRange/2;
			shootingRows=1;

	}
	/**
	 * get resource key
	 */
	protected  String getResourceKey(){
		return "dragon";
	}
	/**
	 * initialize unit at the beginning of a battle
	 * 
	 */
	public void initBattle() {
		super.initBattle();
		arrowSign.setImage(Resources.getSign("dragonbreathcounter"));

	}
	/**
	 * reset unit after end of battle
	 * 
	 * @param winner
	 *            did the unit army won the battle
	 */
	public void endBattle(boolean winner) {
		super.endBattle(winner);
		projectilesNumber = 3;
	}
	/**
	 * @return number of projectiles shot
	 */
	protected int getNbProjectiles() {
		return getWorth();
	}
	/**
	 * @return projectile type
	 */
	public char getProjectileType() {
		return 'f';
	}

	
}
