/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.army.hierarchy;

import fb.army.entities.Entity;
import fb.util.Resources;
/**
 * an allied command
 * @author farfpeuf
 *
 */
public class AllyCommand extends StrangerCommand{


	/**
	 * returns command as a string to save it to a file
	 * 
	 * @return command as a string
	 */
	public String saveString(){
		String savestring="a"+'\t'+name+ '\t' + order + '\t'+ (changedOrders ? 'y' : 'n') +'\n';
		for (int i=0;i<allEntities.size();i++){
			savestring+=(((Entity)allEntities.get(i)).saveString()+ '\n');
		}//for
		return savestring;
	}
	
	/**
	 * @return list of races that can be added to this command
	 */
	public String[] getAvailableRaces(){
		String[] catalog=null;
		String race = army.getRace();
		if (race.equals("barbarian")) {
			catalog = barbarianallies;
		} else if (race.equals("goblin")) {
			catalog = goblinallies;
		} else if (race.equals("dwarf")) {
			catalog = dwarfallies;
		} else if (race.equals("woodelf")) {
			catalog = woodelfallies;
		} else if (race.equals("high-elf")) {
			catalog = highelfallies;
		} else if (race.equals("human")) {
			catalog = humanallies;
		} else {
			catalog = orcallies;
		}
		return catalog;
	}
	
	/**
	 * available allies for each race
	 */
	private static String[] 
	barbarianallies =
		new String[] {
			Resources.getString("aetroll"),
			Resources.getString("aedwarf"),
			Resources.getString("aewoodelf"),
			Resources.getString("aehuman"),
			Resources.getString("aehigh-elf"),
			Resources.getString("aeorc")},
	goblinallies =
		new String[] {
			Resources.getString("aetroll"),
			Resources.getString("aeogre"),
			Resources.getString("aehuman"),
			Resources.getString("aebarbarian"),
			Resources.getString("aeorc")},
	dwarfallies = new String[] {

		Resources.getString("aewoodelf"),
			Resources.getString("aehigh-elf"),
			Resources.getString("aehuman"),
			Resources.getString("aebarbarian")},
	woodelfallies = new String[] {

		Resources.getString("aedwarf"),
			Resources.getString("aehigh-elf"),
			Resources.getString("aehuman"),
			Resources.getString("aebarbarian")},
	highelfallies = new String[] {

		Resources.getString("aedwarf"),
			Resources.getString("aewoodelf"),
			Resources.getString("aehuman")},
	humanallies = new String[] {

		Resources.getString("aedwarf"),
			Resources.getString("aewoodelf"),
			Resources.getString("aebarbarian"),
			Resources.getString("aehigh-elf")},
	orcallies =
		new String[] {
			Resources.getString("aetroll"),
			Resources.getString("aeogre"),
			Resources.getString("aegoblin"),
			Resources.getString("aebarbarian")};
	

}
