/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.battlefield;

import fb.battlefieldelements.Element;

/**
 * an event on the battlefield data model
 * 
 * @author farfpeuf
 * 
 */
public class BattleFieldModelEvent {

	// possible types of events

	public static final int INSERT = 1;

	public static final int UPDATE = 0;

	public static final int DELETE = -1;

	// type of event
	protected int type;

	// battlefield element concerned by this event
	protected Element element;

	/**
	 * @return Returns the element.
	 */
	public Element getElement() {
		return element;
	}

	/**
	 * @return Returns the type.
	 */
	public int getType() {
		return type;
	}

	/**
	 * create a new battlefield model event
	 * 
	 * @param element
	 *            element concerned by this event
	 * @param type
	 *            type of event
	 */
	public BattleFieldModelEvent(Element element, int type) {
		super();
		this.element = element;
		this.type = type;
	}

}
