/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.battlefieldelements;

import java.util.Comparator;

/**
 * Comparator used to sort the battlefield elements in the order in which they
 * must be painted
 * 
 * @author farfpeuf
 * 
 */
public class ElementComparator implements Comparator {

	/**
	 * Compare two battlefield elements to determine which must
	 * be painted first
	 */
	public int compare(Object o1, Object o2) {
		int y1 = ((Element) o1).getY(), y2 = ((Element) o2).getY();
		if (o1 instanceof VerticalSetShadow) {
			return -1;
		}
		if (o2 instanceof VerticalSetShadow) {
			return 1;
		}

		if ((o1 instanceof Warrior && ((Warrior) o1).isflying())
				&& !(o2 instanceof Warrior && ((Warrior) o2).isflying())) {
			return 1;
		}
		if ((o2 instanceof Warrior && ((Warrior) o2).isflying())
				&& !(o1 instanceof Warrior && ((Warrior) o1).isflying())) {
			return -1;
		}
		if (y1 < y2) {
			return -1;
		} else if (y1 > y2) {
			return 1;
		}
		return 0;
	}

}
