/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.gui.frames;
import java.awt.GridLayout;
import java.io.File;

import javax.swing.JPanel;

import fb.gui.widgets.ButtonListener;
import fb.gui.widgets.FBButton;
import fb.main.FB;
import fb.util.Resources;
/**
 * frame used for network game
 * @author Farfpeuf
 */
public class LanFrame extends JPanel {
	/**
	 * singleton instance
	 */
	private static LanFrame instance;
	/**
	 * buttons
	 */
	private FBButton 
		hostlan,
		joinlan,
		exit;
	/**
	 * get singleton instance
	 * @return the singleton
	 */
	public static synchronized  LanFrame getInstance() {
		if (null == instance) {
			instance = new LanFrame();
		}
		return instance;
	}
	/**
	 * delete singleton to free memory
	 *
	 */
	public static synchronized  void freeInstance() {
		if (null != instance) {
			instance = null;
		}
	}
	/**
	 * handle buttons enabling
	 *
	 */
	public void enableButtons() {

		String[] filelist ;

		File armiesdir = new File("armies");
		if (!armiesdir.exists()) {
			armiesdir.mkdir();
		}
		filelist = armiesdir.list();
		boolean atLeastOneArmy = filelist.length != 0;
		hostlan.setEnabled(atLeastOneArmy);
		joinlan.setEnabled(atLeastOneArmy);
	}
	/**
	 * constructor
	 * 
	 * build and assemble elements
	 * 
	 */
	public LanFrame() {

		hostlan = new FBButton(Resources.getString("hostlan"));
		joinlan = new FBButton(Resources.getString("joinlan"));
		exit = new FBButton(Resources.getString("Exittomainmenu"));

		hostlan.addActionListener(new ButtonListener() {
			public void threadedActionPerformed() {
				FB.getInstance().hostLanAction();
			}
		});
		joinlan.addActionListener(new ButtonListener() {
			public void threadedActionPerformed() {
				FB.getInstance().joinLanAction();
			}
		});
		exit.addActionListener(new ButtonListener() {
			public void threadedActionPerformed() {
				FB.getInstance().displayMainMenuFrame();
			}
		});
		setLayout(new GridLayout(3, 1));

		add(hostlan);
		add(joinlan);
		add(exit);
		validate();
		setOpaque(false);
		setBounds(
			(int) (300 * FB.getXres()),
			(int) (260 * FB.getYres()),
			(int) (200 * FB.getXres()),
			(int) (80 * FB.getYres()));
	}
}