/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.gui.panels;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JPanel;

import fb.army.entities.Unit;
import fb.gui.frames.BattleFrame;
import fb.gui.widgets.ButtonValueChooser;
import fb.gui.widgets.FBButton;
import fb.util.Resources;

/**
 * panel for reduce manoeuvre
 * 
 * @author farfpeuf
 * 
 */
public class ReducePanel extends JPanel {
	/**
	 * current unit attempting reduce manoeuvre
	 */
	private Unit unit;

	/**
	 * ok and cancel buttons
	 */
	private FBButton okButton, cancelButton;

	/**
	 * widget used to choose the number of warriors to remove from the front
	 * line
	 */
	private ButtonValueChooser reduceValueChooser;

	/**
	 * change unit attempting reduce manoeuvre
	 * 
	 * @param u
	 *            the new unit
	 */
	public void setUnit(Unit u) {
		unit = u;
		int leveltest = (unit.getLevel() + 1) * 2;
		int canReduce = unit.canReduce();
		int max = leveltest;
		if (max > canReduce) {
			max = canReduce;
		}
		if (max > (unit.getFront() - 1)) {
			max = unit.getFront() - 1;
		}
		reduceValueChooser.setValues(1, max, max);
	}

	/**
	 * constructor build and assemble panel elements
	 */
	public ReducePanel() {

		setLayout(new GridLayout(2, 1));
		okButton = new FBButton(Resources.getString("Reduce"), null, true);
		okButton.setToolTipText(Resources.getString("reduce.tt"));
		cancelButton = new FBButton(Resources.getString("Cancel"), null, true);
		reduceValueChooser = new ButtonValueChooser();
		add(reduceValueChooser);
		JPanel okCancelPanel = new JPanel();
		add(okCancelPanel);
		okCancelPanel.setLayout(new GridLayout(2, 1));
		okCancelPanel.add(okButton);
		okCancelPanel.add(cancelButton);

		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				unit.reduce(reduceValueChooser.getValue());
				BattleFrame.getInstance().setMovementPanel(unit);
			}
		});

		cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				BattleFrame.getInstance().setMovementPanel(unit);
			}
		});

		setSize(60, 120);
		setOpaque(false);
		validate();
	}
}