/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.gui.panels;

import java.awt.GridLayout;

import javax.swing.JPanel;

import fb.gui.widgets.SpellButton;
/**
 * panel to choose a spell
 * @author farfpeuf
 *
 */
public abstract class SpellCasterPanel extends JPanel {
	/**
	 * the available spell buttons
	 */
	protected SpellButton[] buttons;
	/**
	 * enable all the buttons
	 *
	 */
	public void enableAllButtons() {
		for (int i = 0; i < buttons.length; i++) {
			buttons[i].setEnabled(true);
		}
	}

	/**
	 * create all the buttons available in the panel
	 *
	 */
	public abstract void createButtons();
	
	
	/**
	 * constructor
	 * build and assemble panel elements
	 */
	public SpellCasterPanel() {
		setLayout(new GridLayout(2,6));
		
		createButtons();

		
		for (int i = 0; i < buttons.length; i++) {
			add(buttons[i]);
		}
		setSize((buttons.length/2+buttons.length%2)*60, 120);
		setOpaque(false);
		validate();
	}
}