/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.gui.widgets;
import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

import fb.util.FBColors;
/**
 * renderer used by fantasy battlefields combo boxes
 * @author Farfpeuf
 */
public class ComboBoxRenderer extends JLabel implements ListCellRenderer {
	/**
	 * constructor
	 *
	 */
	public ComboBoxRenderer() {
		setOpaque(true);
		setHorizontalAlignment(0);
	}
	/**
	 * ListCellRenderer implementation
	 */
	public Component getListCellRendererComponent(JList list, Object value,
			int index, boolean isSelected, boolean cellHasFocus) {
		if (value != null) {
			setText(value.toString());
		}
		setBackground(isSelected ? FBColors.background : FBColors.background);
		setForeground(isSelected ? FBColors.highlightedText : FBColors.standardText);
		return this;
	}
}