/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.main;

/**
 * a timer thread
 * 
 * @author farfpeuf
 * 
 */
public class Timer extends Thread {


	/**
	 * the timer listener
	 */
	private TimerListener listener;

	/**
	 * interval between each actions
	 */
	private int interval;

	/**
	 * stop the timer ?
	 */
	private boolean end;
	
	/**
	 * constructor
	 * 
	 * @param interval
	 *            time interval between each actions
	 * @param listener
	 *            timer listener
	 */
	public Timer(int interval, TimerListener listener) {
		this.listener = listener;
		this.interval = interval;
		end = false;
	}

	/**
	 * calls every 'time' milliseconds method timeTic() from listener
	 */
	public void run() {
		try {
			while (!interrupted() && !end) {
				listener.timeTic();
				Thread.sleep(interval);
			}
		} catch (InterruptedException e) {
		}
	}

	/**
	 * stop timer safely
	 * 
	 */
	public void safeStop() {
		end = true;
		interrupt();
	}


}
